'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var PropTypes = require('prop-types');
var NanoProvider = require('nano-style').Provider;
// const NanoProvider = require('nano-style/dist/ThemeProvider').default

var ThemeProvider = function (_React$Component) {
  _inherits(ThemeProvider, _React$Component);

  function ThemeProvider() {
    _classCallCheck(this, ThemeProvider);

    return _possibleConstructorReturn(this, (ThemeProvider.__proto__ || Object.getPrototypeOf(ThemeProvider)).apply(this, arguments));
  }

  _createClass(ThemeProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        theme: createTheme(this.props.theme)
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(NanoProvider, { theme: this.props.theme }, React.createElement('div', null, this.props.children));
    }
  }]);

  return ThemeProvider;
}(React.Component);

ThemeProvider.childContextTypes = {
  theme: PropTypes.oneOfType([PropTypes.func, PropTypes.object])
};

var createTheme = function createTheme(theme) {
  return Object.assign(function (keys) {
    return keys.split('.').reduce(function (a, b) {
      return a && a[b] ? a[b] : null;
    }, theme);
  }, theme);
};

module.exports = ThemeProvider;
module.exports.createTheme = createTheme;