'use strict';

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var h = require('react').createElement;
var createComponent = require('./createComponent');
var defaultTheme = require('./theme');

var sortImports = function sortImports(a, b) {
  if (a.imports.includes(b.name) && b.imports.includes(a.name)) return 1;
  if (a.imports.includes(b.name)) return 1;
  if (b.imports.includes(a.name)) return -1;
  return 0;
};

module.exports = function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var base = config.filter(function (c) {
    return c.type && !/^[A-Z]/.test(c.type);
  });
  var extensions = config.filter(function (c) {
    return c.type && /^[A-Z]/.test(c.type);
  });
  var macros = config.filter(function (c) {
    return !c.type && c.imports;
  }).sort(sortImports);

  return [].concat(_toConsumableArray(base), _toConsumableArray(extensions), _toConsumableArray(macros)).reduce(function (a, b) {
    return Object.assign(a, _defineProperty({}, b.name, createComponent(b, a, options)));
  }, {});
};