'use strict';

var _stringifyObject = require('stringify-object');

var SREG = /\$\{.*\}/;
var transform = function transform(obj, prop, original) {
  var val = obj[prop];
  if (SREG.test(val)) {
    return original.replace(/^'/, '`').replace(/'$/, '`').replace(/\\'/g, '\'');
  }
  return original;
};

var stringifyOptions = {
  indent: '  ',
  transform: transform
};

var stringifyObject = function stringifyObject(obj) {
  return _stringifyObject(obj, stringifyOptions);
};

var CREG = /^[A-Z]/;
var getExtensionImport = function getExtensionImport(type) {
  return CREG.test(type) ? 'import ' + type + ' from \'./' + type + '\'\n' : '';
};

var getComp = function getComp(type) {
  return CREG.test(type) ? type : "'" + type + "'";
};
var getSystemFuncs = function getSystemFuncs(funcs) {
  return funcs.join(',\n');
};

module.exports = {
  stringifyObject: stringifyObject,
  getExtensionImport: getExtensionImport,
  getComp: getComp,
  getSystemFuncs: getSystemFuncs
};