'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _require = require('styled-system'),
    theme = _require.theme;

var SREG = /\$\{.*\}/;

var themeGetter = function themeGetter(props) {
  return function (keys) {
    return theme(keys)(props);
  };
};

var createFunctionalStyle = function createFunctionalStyle(props, style) {
  var next = {};
  for (var key in style) {
    var value = style[key];
    if (SREG.test(value)) {
      var fn = new Function('props', 'theme', 'return `' + value + '`');
      next[key] = fn(props, themeGetter(props));
      continue;
    }
    next[key] = value;
  }
  return next;
};

module.exports = function (config) {
  var style = _typeof(config.style) === 'object' ? function (props) {
    return createFunctionalStyle(props, config.style);
  } : config.style;

  return Object.assign({}, config, {
    style: style
  });
};